package org.fluttercode.resourcedemo.resourcedemo;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Event;
import javax.enterprise.inject.Produces;
import javax.faces.context.FacesContext;
import javax.inject.Inject;

@RequestScoped
public class MessageProvider {

	private ResourceBundle bundle;
	
	@Inject
	private Event<MissingResourceInfo> event;

	@Produces
	@MessageBundle	
	public ResourceBundle getBundle() {
		if (bundle == null) {
			FacesContext context = FacesContext.getCurrentInstance();
			bundle = context.getApplication().getResourceBundle(context, "msgs");
		}
		return bundle;
	}

	public String getValue(String key) {

		String result = null;
		try {
			result = getBundle().getString(key);
		} catch (MissingResourceException e) {			
			result = "???" + key + "??? not found";
			event.fire(new MissingResourceInfo(key, getBundle().getLocale()));
		}
		return result;
	}

}
